VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cPOSLine"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"3D3EBFA403AC"
'<CAMH>****************************************************************************************
'* Module: cPOSLine
'* Date  : 09/08/02
'* Author: mauricem
'*$Archive: /Projects/OasysV2/VB/SalesBO/POSLine.cls $
'**********************************************************************************************
'* Summary: Business Object to wrap the functionality of the Till Sales Slip Lines
'**********************************************************************************************
'* $Author: Richardc $
'* $Date: 3/06/04 10:17 $
'* $Revision: 12 $
'* Versions:
'* 09/08/02    mauricem
'*             Header added.
'</CAMH>***************************************************************************************
Option Base 0
Option Explicit

Const MODULE_NAME As String = "cPOSLine"

Implements IBo
Implements ISysBo

Private Const POS_LINE_REFUND_CODE As String = "R"

Private moRowSel As IRowSelector

Private moLoadRow As IRowSelector

Private m_oSession As Session

'##ModelId=3D4547260384
Private mTranDate As Date

'##ModelId=3D45472E0366
Private mTillID As String

'##ModelId=3D4547330104
Private mTransactionNumber As String

'##ModelId=3D454738032A
Private mSequenceNo As Long

'##ModelId=3D45473F0348
Private mPartCode As String

'##ModelId=3D4547430082
Private mDepartmentNumber As String

'##ModelId=3D45474802E4
Private mBarcodeEntry As Boolean

'##ModelId=3D454759021C
Private mQuantitySold As Long

'##ModelId=3D53CBC4024E
Private mActualSellPrice As Currency

'##ModelId=3D45477A0078
Private mExtendedValue As Currency

'##ModelId=3D45479201F4
Private mExtendedCost As Double

'##ModelId=3D45479F00BE
Private mLookUpPrice As Currency

'##ModelId=3D4547C200E6
Private mVATCode As String

'##ModelId=3D4547DD0028
Private mRelatedItems As Boolean

'##ModelId=3D4547E40078
Private mCatchAllItem As Boolean

'##ModelId=3D4547EB0104
Private mLineReversed As Boolean

'##ModelId=3D4547F100FA
Private mPriceOverrideReason As Long

'##ModelId=3D454804035C
Private mSupervisorNumber As String

'##ModelId=3D45480F0348
Private mActualPriceExVAT As Currency

'##ModelId=3D454879015E
Private mOverrideMarginCode As String

Private mLastEventSequenceNo As String
Private mHierCategory As String
Private mHierGroup As String
Private mHierSubGroup As String
Private mHierStyle As String
Private mQuarantineSupervisor As String
Private mEmpSaleSecondaryMarginAmount As Currency
Private mMarkedDownStock As Boolean
Private mSaleType As String
Private mVATCodeNumber As Long
Private mPriceOverrideAmount As Currency
Private mItemTagged As Boolean
Private mTempPriceMarginAmount As Currency
Private mTempPriceMarginCode As String
Private mQtyBreakMarginAmount As Currency
Private mQtyBreakMarginCode As String
Private mDealGroupMarginAmount As Currency
Private mDealGroupMarginCode As String
Private mMultiBuyMarginAmount As Currency
Private mMultiBuyMarginCode As String
Private mHierarchyMarginAmount As Currency
Private mHierarchyMarginCode As String
Private mEmpSalePrimaryMarginAmount As Currency
Private mEmpSalePrimaryMarginCode As String
Private mVATAmount As Currency
Private mBackDoorCollect As Boolean
        
Private mApplyToStock As Boolean

Private mReversalCode As String 'WIX1202 - record reason why line reverse (to catch mis-labelled items)

Private mWEEERate       As String
Private mWEEESequence   As String
Private mWEEELineCharge As Currency

Private mMarkDownSerialNumber As String

Public POSHeader As cPOSHeader

Public Property Get ReversalCode() As String
   Let ReversalCode = mReversalCode
End Property

Public Property Let ReversalCode(ByVal Value As String)
    Let mReversalCode = Value
End Property

Public Property Get ApplyToStock() As Boolean
   Let ApplyToStock = mApplyToStock
End Property

'##ModelId=3D53CE4D02F8
Public Property Let ApplyToStock(ByVal Value As Boolean)
    Let mApplyToStock = Value
End Property

'##ModelId=3D53CE3C0014
Public Property Get OverrideMarginCode() As String
   Let OverrideMarginCode = mOverrideMarginCode
End Property

'##ModelId=3D53CE3B00FA
Public Property Let OverrideMarginCode(ByVal Value As String)
    Let mOverrideMarginCode = Value
End Property

'##ModelId=3D53CE370190
Public Property Get ActualPriceExVAT() As Currency
   Let ActualPriceExVAT = mActualPriceExVAT
End Property

'##ModelId=3D53CE360320
Public Property Let ActualPriceExVAT(ByVal Value As Currency)
    Let mActualPriceExVAT = Value
End Property

'##ModelId=3D53CE36019A
Public Property Get SupervisorNumber() As String
   Let SupervisorNumber = mSupervisorNumber
End Property

'##ModelId=3D53CE35032A
Public Property Let SupervisorNumber(ByVal Value As String)
    Let mSupervisorNumber = Value
End Property

'##ModelId=3D53CE3401EA
Public Property Get PriceOverrideReason() As Long
   Let PriceOverrideReason = mPriceOverrideReason
End Property

'##ModelId=3D53CE33037A
Public Property Let PriceOverrideReason(ByVal Value As Long)
    Let mPriceOverrideReason = Value
End Property

'##ModelId=3D53CE3301F4
Public Property Get LineReversed() As Boolean
   Let LineReversed = mLineReversed
End Property

'##ModelId=3D53CE3203B6
Public Property Let LineReversed(ByVal Value As Boolean)
    Let mLineReversed = Value
End Property

'##ModelId=3D53CE32026C
Public Property Get CatchAllItem() As Boolean
   Let CatchAllItem = mCatchAllItem
End Property

'##ModelId=3D53CE320050
Public Property Let CatchAllItem(ByVal Value As Boolean)
    Let mCatchAllItem = Value
End Property

'##ModelId=3D53CE3102B2
Public Property Get RelatedItems() As Boolean
   Let RelatedItems = mRelatedItems
End Property

'##ModelId=3D53CE31008C
Public Property Let RelatedItems(ByVal Value As Boolean)
    Let mRelatedItems = Value
End Property

'##ModelId=3D53CE30032A
Public Property Get VATCode() As String
   Let VATCode = mVATCode
End Property

'##ModelId=3D53CE300140
Public Property Let VATCode(ByVal Value As String)
    Let mVATCode = Value
End Property

'##ModelId=3D53CE2E0154
Public Property Get LookUpPrice() As Currency
   Let LookUpPrice = mLookUpPrice
End Property

'##ModelId=3D53CE2D0352
Public Property Let LookUpPrice(ByVal Value As Currency)
    Let mLookUpPrice = Value
End Property

'##ModelId=3D53CE2D023A
Public Property Get ExtendedCost() As Double
   Let ExtendedCost = mExtendedCost
End Property

'##ModelId=3D53CE2D0050
Public Property Let ExtendedCost(ByVal Value As Double)
    Let mExtendedCost = Value
End Property

'##ModelId=3D53CE2C0320
Public Property Get ExtendedValue() As Currency
   Let ExtendedValue = mExtendedValue
End Property

'##ModelId=3D53CE2C0168
Public Property Let ExtendedValue(ByVal Value As Currency)
    Let mExtendedValue = Value
End Property

'##ModelId=3D53CE2B0140
Public Property Get ActualSellPrice() As Currency
   Let ActualSellPrice = mActualSellPrice
End Property

'##ModelId=3D53CE2A0370
Public Property Let ActualSellPrice(ByVal Value As Currency)
    Let mActualSellPrice = Value
End Property

'##ModelId=3D53CE2A0262
Public Property Get QuantitySold() As Long
   Let QuantitySold = mQuantitySold
End Property

'##ModelId=3D53CE2A00AA
Public Property Let QuantitySold(ByVal Value As Long)
    Let mQuantitySold = Value
End Property

'##ModelId=3D53CE2903B6
Public Property Get BarcodeEntry() As Boolean
   Let BarcodeEntry = mBarcodeEntry
End Property

'##ModelId=3D53CE2901FE
Public Property Let BarcodeEntry(ByVal Value As Boolean)
    Let mBarcodeEntry = Value
End Property

'##ModelId=3D53CE2900E6
Public Property Get DepartmentNumber() As String
   Let DepartmentNumber = mDepartmentNumber
End Property

'##ModelId=3D53CE280352
Public Property Let DepartmentNumber(ByVal Value As String)
    Let mDepartmentNumber = Value
End Property

'##ModelId=3D53CE280276
Public Property Get PartCode() As String
   Let PartCode = mPartCode
End Property

'##ModelId=3D53CE2800F0
Public Property Let PartCode(ByVal Value As String)
    Let mPartCode = Value
End Property

'##ModelId=3D53CE2703CA
Public Property Get SequenceNo() As Long
   Let SequenceNo = mSequenceNo
End Property

'##ModelId=3D53CE270280
Public Property Let SequenceNo(ByVal Value As Long)
    Let mSequenceNo = Value
End Property

'##ModelId=3D53CE2701A4
Public Property Get TransactionNumber() As String
   Let TransactionNumber = mTransactionNumber
End Property

'##ModelId=3D53CE270028
Public Property Let TransactionNumber(ByVal Value As String)
    Let mTransactionNumber = Value
End Property

'##ModelId=3D53CE260334
Public Property Get TillID() As String
   Let TillID = mTillID
End Property

'##ModelId=3D53CE2601EA
Public Property Let TillID(ByVal Value As String)
    Let mTillID = Value
End Property

'##ModelId=3D53CE26010E
Public Property Get TranDate() As Date
   Let TranDate = mTranDate
End Property

'##ModelId=3D53CE2503AC
Public Property Let TranDate(ByVal Value As Date)
    Let mTranDate = Value
End Property

Public Property Get LastEventSequenceNo() As String
    LastEventSequenceNo = mLastEventSequenceNo
End Property

Public Property Let LastEventSequenceNo(ByVal Value As String)
    mLastEventSequenceNo = Value
End Property

Public Property Get HierCategory() As String
    HierCategory = mHierCategory
End Property

Public Property Let HierCategory(ByVal Value As String)
    mHierCategory = Value
End Property

Public Property Get HierGroup() As String
    HierGroup = mHierGroup
End Property

Public Property Let HierGroup(ByVal Value As String)
    mHierGroup = Value
End Property

Public Property Get HierSubGroup() As String
    HierSubGroup = mHierSubGroup
End Property

Public Property Let HierSubGroup(ByVal Value As String)
    mHierSubGroup = Value
End Property

Public Property Get HierStyle() As String
    HierStyle = mHierStyle
End Property

Public Property Let HierStyle(ByVal Value As String)
    mHierStyle = Value
End Property

Public Property Get QuarantineSupervisor() As String
    QuarantineSupervisor = mQuarantineSupervisor
End Property

Public Property Let QuarantineSupervisor(ByVal Value As String)
    mQuarantineSupervisor = Value
End Property

Public Property Get EmpSaleSecondaryMarginAmount() As Currency
    EmpSaleSecondaryMarginAmount = mEmpSaleSecondaryMarginAmount
End Property

Public Property Let EmpSaleSecondaryMarginAmount(ByVal Value As Currency)
    mEmpSaleSecondaryMarginAmount = Value
End Property

Public Property Get MarkedDownStock() As Boolean
    MarkedDownStock = mMarkedDownStock
End Property

Public Property Let MarkedDownStock(ByVal Value As Boolean)
    mMarkedDownStock = Value
End Property

Public Property Get SaleType() As String
    SaleType = mSaleType
End Property

Public Property Let SaleType(ByVal Value As String)
    mSaleType = Value
End Property

Public Property Get VATCodeNumber() As Long
    VATCodeNumber = mVATCodeNumber
End Property

Public Property Let VATCodeNumber(ByVal Value As Long)
    mVATCodeNumber = Value
End Property

Public Property Get PriceOverrideAmount() As Currency
    PriceOverrideAmount = mPriceOverrideAmount
End Property

Public Property Let PriceOverrideAmount(ByVal Value As Currency)
    mPriceOverrideAmount = Value
End Property

Public Property Get ItemTagged() As Boolean
    ItemTagged = mItemTagged
End Property

Public Property Let ItemTagged(ByVal Value As Boolean)
    mItemTagged = Value
End Property

Public Property Get TempPriceMarginAmount() As Currency
    TempPriceMarginAmount = mTempPriceMarginAmount
End Property

Public Property Let TempPriceMarginAmount(ByVal Value As Currency)
    mTempPriceMarginAmount = Value
End Property

Public Property Get TempPriceMarginCode() As String
    TempPriceMarginCode = mTempPriceMarginCode
End Property

Public Property Let TempPriceMarginCode(ByVal Value As String)
    mTempPriceMarginCode = Value
End Property

Public Property Get QtyBreakMarginAmount() As Currency
    QtyBreakMarginAmount = mQtyBreakMarginAmount
End Property

Public Property Let QtyBreakMarginAmount(ByVal Value As Currency)
    mQtyBreakMarginAmount = Value
End Property

Public Property Get QtyBreakMarginCode() As String
    QtyBreakMarginCode = mQtyBreakMarginCode
End Property

Public Property Let QtyBreakMarginCode(ByVal Value As String)
    mQtyBreakMarginCode = Value
End Property

Public Property Get DealGroupMarginAmount() As Currency
    DealGroupMarginAmount = mDealGroupMarginAmount
End Property

Public Property Let DealGroupMarginAmount(ByVal Value As Currency)
    mDealGroupMarginAmount = Value
End Property

Public Property Get DealGroupMarginCode() As String
    DealGroupMarginCode = mDealGroupMarginCode
End Property

Public Property Let DealGroupMarginCode(ByVal Value As String)
    mDealGroupMarginCode = Value
End Property

Public Property Get MultiBuyMarginAmount() As Currency
    MultiBuyMarginAmount = mMultiBuyMarginAmount
End Property

Public Property Let MultiBuyMarginAmount(ByVal Value As Currency)
    mMultiBuyMarginAmount = Value
End Property

Public Property Get MultiBuyMarginCode() As String
    MultiBuyMarginCode = mMultiBuyMarginCode
End Property

Public Property Let MultiBuyMarginCode(ByVal Value As String)
    mMultiBuyMarginCode = Value
End Property

Public Property Get HierarchyMarginAmount() As Currency
    HierarchyMarginAmount = mHierarchyMarginAmount
End Property

Public Property Let HierarchyMarginAmount(ByVal Value As Currency)
    mHierarchyMarginAmount = Value
End Property

Public Property Get HierarchyMarginCode() As String
    HierarchyMarginCode = mHierarchyMarginCode
End Property

Public Property Let HierarchyMarginCode(ByVal Value As String)
    mHierarchyMarginCode = Value
End Property

Public Property Get EmpSalePrimaryMarginAmount() As Currency
    EmpSalePrimaryMarginAmount = mEmpSalePrimaryMarginAmount
End Property

Public Property Let EmpSalePrimaryMarginAmount(ByVal Value As Currency)
    mEmpSalePrimaryMarginAmount = Value
End Property

Public Property Get EmpSalePrimaryMarginCode() As String
    EmpSalePrimaryMarginCode = mEmpSalePrimaryMarginCode
End Property

Public Property Let EmpSalePrimaryMarginCode(ByVal Value As String)
    mEmpSalePrimaryMarginCode = Value
End Property

Public Property Get VATAmount() As Currency
    VATAmount = mVATAmount
End Property

Public Property Let VATAmount(ByVal Value As Currency)
    mVATAmount = Value
End Property

Public Property Get BackDoorCollect() As Boolean
    BackDoorCollect = mBackDoorCollect
End Property

Public Property Let BackDoorCollect(ByVal Value As Boolean)
    mBackDoorCollect = Value
End Property

Public Property Get WEEELineCharge() As Currency
   Let WEEELineCharge = mWEEELineCharge
End Property

Public Property Let WEEELineCharge(ByVal Value As Currency)
    Let mWEEELineCharge = Value
End Property


Public Property Get WEEERate() As String
   Let WEEERate = mWEEERate
End Property

Public Property Let WEEERate(ByVal Value As String)
    Let mWEEERate = Value
End Property

Public Property Get WEEESequence() As String
   Let WEEESequence = mWEEESequence
End Property

Public Property Let WEEESequence(ByVal Value As String)
    Let mWEEESequence = Value
End Property

Public Property Get MarkDownSerialNumber() As String
    Let MarkDownSerialNumber = mMarkDownSerialNumber
End Property

Public Property Let MarkDownSerialNumber(ByVal Value As String)
    Let mMarkDownSerialNumber = Value
End Property

'<CACH>****************************************************************************************
'* Function:  Boolean LoadFromRow()
'**********************************************************************************************
'* Description: Part of the IBo interface called by the DB object to pass in a row of field and
'*              for this object to extract the data and populate the properties of the object.
'**********************************************************************************************
'* Parameters:
'*In/Out:oRow   Object. - collection of fields
'**********************************************************************************************
'* Returns:  Boolean
'**********************************************************************************************
'* History:
'* 08/08/02    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Function LoadFromRow(oRow As IRow) As Boolean

Dim lFieldNo As Integer
Dim oField   As IField

Const PROCEDURE_NAME As String = MODULE_NAME & ".IBo_LoadFromRow"

    LoadFromRow = True
    For lFieldNo = 1 To oRow.Count Step 1
        Set oField = oRow.Field(lFieldNo)
        Select Case (oField.Id)
            Case (FID_POSLINE_TranDate):              mTranDate = oField.ValueAsVariant
            Case (FID_POSLINE_TillID):                mTillID = oField.ValueAsVariant
            Case (FID_POSLINE_TransactionNumber):     mTransactionNumber = oField.ValueAsVariant
            Case (FID_POSLINE_SequenceNo):            mSequenceNo = oField.ValueAsVariant
            Case (FID_POSLINE_PartCode):              mPartCode = oField.ValueAsVariant
            Case (FID_POSLINE_DepartmentNumber):      mDepartmentNumber = oField.ValueAsVariant
            Case (FID_POSLINE_BarcodeEntry):          mBarcodeEntry = oField.ValueAsVariant
            Case (FID_POSLINE_QuantitySold):          mQuantitySold = oField.ValueAsVariant
            Case (FID_POSLINE_ActualSellPrice):       mActualSellPrice = oField.ValueAsVariant
            Case (FID_POSLINE_ExtendedValue):         mExtendedValue = oField.ValueAsVariant
            Case (FID_POSLINE_ExtendedCost):          mExtendedCost = oField.ValueAsVariant
            Case (FID_POSLINE_LookUpPrice):           mLookUpPrice = oField.ValueAsVariant
            Case (FID_POSLINE_VATCode):               mVATCode = oField.ValueAsVariant
            Case (FID_POSLINE_RelatedItems):          mRelatedItems = oField.ValueAsVariant
            Case (FID_POSLINE_CatchAllItem):          mCatchAllItem = oField.ValueAsVariant
            Case (FID_POSLINE_LineReversed):          mLineReversed = oField.ValueAsVariant
            Case (FID_POSLINE_PriceOverrideReason):   mPriceOverrideReason = oField.ValueAsVariant
            Case (FID_POSLINE_SupervisorNumber):      mSupervisorNumber = oField.ValueAsVariant
            Case (FID_POSLINE_ActualPriceExVAT):      mActualPriceExVAT = oField.ValueAsVariant
            Case (FID_POSLINE_OverrideMarginCode):    mOverrideMarginCode = oField.ValueAsVariant
            Case (FID_POSLINE_LastEventSequenceNo):   mLastEventSequenceNo = oField.ValueAsVariant
            Case (FID_POSLINE_HierCategory):          mHierCategory = oField.ValueAsVariant
            Case (FID_POSLINE_HierGroup):             mHierGroup = oField.ValueAsVariant
            Case (FID_POSLINE_HierSubGroup):          mHierSubGroup = oField.ValueAsVariant
            Case (FID_POSLINE_HierStyle):             mHierStyle = oField.ValueAsVariant
            Case (FID_POSLINE_QuarantineSupervisor):  mQuarantineSupervisor = oField.ValueAsVariant
            Case (FID_POSLINE_EmpSaleSecondaryMarginAmount): mEmpSaleSecondaryMarginAmount = oField.ValueAsVariant
            Case (FID_POSLINE_MarkedDownStock):       mMarkedDownStock = oField.ValueAsVariant
            Case (FID_POSLINE_SaleType):              mSaleType = oField.ValueAsVariant
            Case (FID_POSLINE_VATCodeNumber):         mVATCodeNumber = oField.ValueAsVariant
            Case (FID_POSLINE_PriceOverrideAmount):   mPriceOverrideAmount = oField.ValueAsVariant
            Case (FID_POSLINE_ItemTagged):            mItemTagged = oField.ValueAsVariant
            Case (FID_POSLINE_TempPriceMarginAmount): mTempPriceMarginAmount = oField.ValueAsVariant
            Case (FID_POSLINE_TempPriceMarginCode):   mTempPriceMarginCode = oField.ValueAsVariant
            Case (FID_POSLINE_QtyBreakMarginAmount):  mQtyBreakMarginAmount = oField.ValueAsVariant
            Case (FID_POSLINE_QtyBreakMarginCode):    mQtyBreakMarginCode = oField.ValueAsVariant
            Case (FID_POSLINE_DealGroupMarginAmount): mDealGroupMarginAmount = oField.ValueAsVariant
            Case (FID_POSLINE_DealGroupMarginCode):   mDealGroupMarginCode = oField.ValueAsVariant
            Case (FID_POSLINE_MultiBuyMarginAmount):  mMultiBuyMarginAmount = oField.ValueAsVariant
            Case (FID_POSLINE_MultiBuyMarginCode):    mMultiBuyMarginCode = oField.ValueAsVariant
            Case (FID_POSLINE_HierarchyMarginAmount): mHierarchyMarginAmount = oField.ValueAsVariant
            Case (FID_POSLINE_HierarchyMarginCode):   mHierarchyMarginCode = oField.ValueAsVariant
            Case (FID_POSLINE_EmpSalePrimaryMarginAmount): mEmpSalePrimaryMarginAmount = oField.ValueAsVariant
            Case (FID_POSLINE_EmpSalePrimaryMarginCode): mEmpSalePrimaryMarginCode = oField.ValueAsVariant
            Case (FID_POSLINE_VATAmount):             mVATAmount = oField.ValueAsVariant
            Case (FID_POSLINE_BackDoorCollect):       mBackDoorCollect = IIf(oField.ValueAsVariant = "Y", True, False)
            Case (FID_POSLINE_BackDoorCollectInd):    mBackDoorCollect = mBackDoorCollect ' this is being ignored at moment
            Case (FID_POSLINE_WEEERate):              mWEEERate = oField.ValueAsVariant
            Case (FID_POSLINE_WEEESequence):          mWEEESequence = oField.ValueAsVariant
            Case (FID_POSLINE_WEEELineCharge):        mWEEELineCharge = oField.ValueAsVariant
            Case (FID_POSLINE_ReversalCode):          mReversalCode = oField.ValueAsVariant
            Case Else: 'invalid field ID passed in
                LoadFromRow = False
        End Select
    Next lFieldNo

End Function 'LoadFromRow

Public Property Get IBo_ClassId() As Integer

    IBo_ClassId = CLASSID_POSLINE

End Property

Public Property Get IBo_ClassName() As String

    IBo_ClassName = MODULE_NAME

End Property

Private Property Get IBo_DebugString() As String

    IBo_DebugString = "POSLine " & mTransactionNumber & " Line " & mSequenceNo

End Property

Private Function IBo_Initialise(oSession As ISession) As IBo
    
    Set m_oSession = oSession
    Set IBo_Initialise = Me

End Function

Private Function ISysBo_LoadFromRow(oRow As IRow) As Boolean

    Call LoadFromRow(oRow)

End Function

Private Property Get IBo_Version() As String
    
    IBo_Version = App.Major & "." & App.Minor & "." & App.Revision

End Property


Private Function Load() As Boolean
    
' Load up all properties from the database
Dim oView       As IView
    
    Load = False
    Call CheckIsUnInitialised(m_oSession, IBo_ClassName)
    
    If moRowSel Is Nothing Then Set moRowSel = New CRowSelector
    Call moRowSel.Merge(GetSelectAllRow)
    
    ' Pass the selector to the database to get the data view
    Set oView = m_oSession.Database.GetView(moRowSel)
    If Not (oView Is Nothing) Then
        If oView.Count > 0 Then Load = LoadFromRow(oView.Row(1))
    End If

End Function

Public Function IBo_Save() As Boolean

    IBo_Save = Save(SaveTypeAllCases)

End Function

Public Function IBo_SaveIfNew() As Boolean
    IBo_SaveIfNew = SaveIfNew
End Function

Public Function SaveIfNew() As Boolean

    SaveIfNew = Save(SaveTypeIfNew)

End Function

Public Function IBo_SaveIfExists() As Boolean
    IBo_SaveIfExists = SaveIfExists
End Function

Public Function SaveIfExists() As Boolean

    SaveIfExists = Save(SaveTypeIfExists)

End Function

Public Function IBo_Delete() As Boolean
    IBo_Delete = False
End Function

Public Function Delete() As Boolean

    Delete = Save(SaveTypeDelete)

End Function

Public Function IBo_IsValid() As Boolean

    IBo_IsValid = IsValid()

End Function


'##ModelId=3D3D19F30316
Private Function Save(eSave As enSaveType) As Boolean

'Static oStockLog  As cStockLog
Dim oStockMove As cStockMovement
'Dim oStockItem As cInventory
'Dim oStockWix  As cInventoryWickes
Dim cExtPrice  As Currency
Dim colWork    As Collection
Dim lIndex     As Long
Dim oUpdateRow As CRow

Dim lLargeKey   As Long
Dim lLargeIndex As Long

' StockLog search
Dim oRowSel     As CRowSelector
Dim oFieldSel   As CFieldSelector
Dim vntKey      As Variant

Dim oConnection As Connection
Dim rsStock        As New Recordset
Dim rsStockLog     As New Recordset

Dim strQuery       As String
Dim strMoveType    As String
Dim strError       As String
Dim strLogFile     As String

Dim fErrorLog As TextStream
Dim oFileSys  As FileSystemObject
            
Dim lngStartQty   As Long
Dim lngStartRet   As Long
Dim curStartPrice As Currency
Dim lngStartMDQ   As Long
Dim lngStartWOQ   As Long

Dim lngQuantityAtHand   As Long
Dim lngMarkDownQuantity As Long

Dim lngQtySoldLF     As Long 'used to store quantity if STKMAS locked
Dim lngQtyMarkDownLF As Long 'used to store quantity if STKMAS locked

Dim lngUnitsSoldYesterday  As Long
Dim lngUnitsSoldThisWeek   As Long
Dim lngUnitsSoldThisPeriod As Long
Dim lngUnitsSoldThisYear   As Long

Dim curValueSoldYesterday  As Currency
Dim curValueSoldThisWeek   As Currency
Dim curValueSoldThisPeriod As Currency
Dim curValueSoldThisYear   As Currency

Dim oMarkdown As cMarkDownStock

' Save all properties to the database
    Save = False
    
    Call DebugMsg(MODULE_NAME, "Save", endlDebug, "Enter")
    
    'Determine Stock Movement type based on Quantity Sign and if Back Door Collection
    If mQuantitySold > 0 Then
        strMoveType = "01"
    Else
        strMoveType = "02"
    End If
    
    If mMarkedDownStock Then
        strMoveType = "04"
    End If
    
    If (mBackDoorCollect = True) Then 'WIX 1161 - new Type for all Back door Items
        strMoveType = "05"
    End If
    
    Set oConnection = m_oSession.Database.Connection

    Call DebugMsg(MODULE_NAME, "Save", endlDebug, "Before Validation")
    If IsValid() Then
        If eSave = SaveTypeIfNew Then
            If LenB(mPartCode) = 0 Then mPartCode = "000000"
            If LenB(mSupervisorNumber) = 0 Then mSupervisorNumber = "000"
            If LenB(mTempPriceMarginCode) = 0 Then mTempPriceMarginCode = "000000"
            If LenB(mPriceOverrideReason) = 0 Then mPriceOverrideReason = "000000"
            If LenB(mQtyBreakMarginCode) = 0 Then mQtyBreakMarginCode = "000000"
            If LenB(mDealGroupMarginCode) = 0 Then mDealGroupMarginCode = "000000"
            If LenB(mMultiBuyMarginCode) = 0 Then mMultiBuyMarginCode = "000000"
            If LenB(mHierarchyMarginCode) = 0 Then mHierarchyMarginCode = "000000"
            If LenB(mEmpSalePrimaryMarginCode) = 0 Then mEmpSalePrimaryMarginCode = "000000"
            If LenB(mSequenceNo) = 0 Then mSequenceNo = "000000"
            If LenB(mHierCategory) = 0 Then mHierCategory = "000000"
            If LenB(mHierGroup) = 0 Then mHierGroup = "000000"
            If LenB(mHierSubGroup) = 0 Then mHierSubGroup = "000000"
            If LenB(mHierStyle) = 0 Then mHierStyle = "000000"
            If LenB(mQuarantineSupervisor) = 0 Then mQuarantineSupervisor = "000"
            If LenB(mLastEventSequenceNo) = 0 Then mLastEventSequenceNo = "000000"
            If LenB(mOverrideMarginCode) = 0 Then mOverrideMarginCode = "000000"
            mDepartmentNumber = "00"
            If LenB(mWEEERate) = 0 Then mWEEERate = "00"
            If LenB(mWEEESequence) = 0 Then mWEEESequence = "00"
        End If
        
        If mMarkDownSerialNumber <> "" Then  'MO'C WIX 1302
            Set oMarkdown = m_oSession.Database.CreateBusinessObject(CLASSID_MARKDOWNSTOCK)
            Call oMarkdown.AddLoadFilter(CMP_EQUAL, FID_MARKDOWNSTOCK_SKUNumber, mPartCode)
            Call oMarkdown.AddLoadFilter(CMP_EQUAL, FID_MARKDOWNSTOCK_Serial, mMarkDownSerialNumber)
            Call oMarkdown.LoadMatches
            PriceOverrideReason = Val(oMarkdown.ReasonCode)
        End If

        Call DebugMsg(MODULE_NAME, "Save", endlDebug, "Before Insert")
        If (m_oSession.Database.SaveBo(eSave, Me) = False) Then Exit Function
        
        If mMarkDownSerialNumber <> "" And (POSHeader.Voided = False) Then  'MO'C WIX 1302 - mark as sold
            Set oMarkdown = m_oSession.Database.CreateBusinessObject(CLASSID_MARKDOWNSTOCK)
            Call oMarkdown.RecordAsSold(mPartCode, mMarkDownSerialNumber, mTranDate, mTransactionNumber, mTillID)
        End If
        
        Call DebugMsg(MODULE_NAME, "Save", endlDebug, "Begin Stock Tracking")
        If (POSHeader.TranParked = False) And (POSHeader.Voided = False) And _
           (mApplyToStock = True) And (mLineReversed = False) And _
           (POSHeader.TrainingMode = False) Then 'ensure a valid transaction and line
            'Record Stock movement log entry
            Call DebugMsg(MODULE_NAME, "Save", endlTraceIn, "Read last stklog Record")
            Call rsStock.Open("select max(TKEY) as ""MaxKey"" from stklog where type <> '99' and dayn > 0 and skun ='" & mPartCode & "'", oConnection, adOpenStatic)
            vntKey = rsStock.Fields("MaxKey")
            rsStock.Close
            Set rsStock.ActiveConnection = Nothing
            Call DebugMsg(MODULE_NAME, "Save", endlTraceIn, "stkmas Read")
            Call rsStock.Open("select SKUN ""PartCode"", ONHA ""QuantityAtHand"", RETQ ""UnitsInOpenReturns"", MDNQ ""MarkDownQuantity"", WTFQ ""WriteOffQuantity"", PRIC ""NormalSellPrice"", SALU1 ""UnitsSoldYesterday"", SALU2 ""UnitsSoldThisWeek"", SALU4 ""UnitsSoldThisPeriod"",SALU6 ""UnitsSoldThisYear"",SALV1 ""ValueSoldYesterday"",SALV2 ""ValueSoldThisWeek"", SALV4 ""ValueSoldThisPeriod"", SALV6 ""ValueSoldThisYear"", SALT ""SaleTypeAttribute"" FROM STKMAS WHERE SKUN = '" & mPartCode & "' order by skun", oConnection, adOpenStatic)
            Call DebugMsg(MODULE_NAME, "Save", endlTraceOut, "stkmas Read")
            If rsStock.RecordCount = 0 Then
                rsStock.Close
                Set rsStock.ActiveConnection = Nothing
                Exit Function
            End If
            
            lngStartQty = rsStock!QuantityAtHand
            lngStartRet = rsStock!UnitsInOpenReturns
            curStartPrice = rsStock!NormalSellPrice
            lngStartMDQ = rsStock!MarkDownQuantity
            lngStartWOQ = rsStock!WriteOffQuantity
            rsStock.Close
            Set rsStock.ActiveConnection = Nothing
            
            If Not IsNull(vntKey) Then
                Call DebugMsg(MODULE_NAME, "Save", endlTraceIn, "stklog Read-" & vntKey)
                Call rsStockLog.Open("select * from stklog where tkey=" & vntKey & " order by tkey", oConnection, adOpenStatic)
                Call DebugMsg(MODULE_NAME, "Save", endlTraceOut, "stklog Read")

                With rsStockLog
                    
                    If !ESTK <> lngStartQty Or _
                       !ERET <> lngStartRet Or _
                       !EMDN <> lngStartMDQ Or _
                       !EWTF <> lngStartWOQ Then
                        Call WriteIntoStkLogSystemAdjustment91(mPartCode, POSHeader.CashierID, !ESTK, _
                            !ERET, !EMDN, !EWTF, !EPRI, lngStartQty, lngStartRet, lngStartMDQ, _
                            lngStartWOQ, curStartPrice)
                    End If
                End With
                rsStockLog.Close
                Set rsStockLog.ActiveConnection = Nothing
            Else
                If lngStartQty <> 0 Then
                    Call WriteIntoStkLogSystemAdjustment91(mPartCode, POSHeader.CashierID, 0, _
                        0, 0, 0, 0, lngStartQty, lngStartRet, lngStartMDQ, _
                        lngStartWOQ, curStartPrice)
            End If
            End If
            
            'Added STKMAS reload
            Call DebugMsg(MODULE_NAME, "Save", endlTraceIn, "stkmas Close")
            Call rsStock.Open("select SKUN ""PartCode"", ONHA ""QuantityAtHand"", RETQ ""UnitsInOpenReturns"", MDNQ ""MarkDownQuantity"", WTFQ ""WriteOffQuantity"", PRIC ""NormalSellPrice"", SALU1 ""UnitsSoldYesterday"", SALU2 ""UnitsSoldThisWeek"", SALU4 ""UnitsSoldThisPeriod"",SALU6 ""UnitsSoldThisYear"",SALV1 ""ValueSoldYesterday"",SALV2 ""ValueSoldThisWeek"", SALV4 ""ValueSoldThisPeriod"", SALV6 ""ValueSoldThisYear"", SALT ""SaleTypeAttribute"" FROM STKMAS WHERE SKUN = '" & mPartCode & "'", oConnection)
            Call DebugMsg(MODULE_NAME, "Save", endlTraceOut, "stkmas Re-Read")
            
            lngStartQty = rsStock!QuantityAtHand
            lngStartRet = rsStock!UnitsInOpenReturns
            curStartPrice = rsStock!NormalSellPrice
            lngStartMDQ = rsStock!MarkDownQuantity
            lngStartWOQ = rsStock!WriteOffQuantity
            
            If rsStock!SaleTypeAttribute <> "D" And _
               rsStock!SaleTypeAttribute <> "I" Then
                If mMarkedDownStock Then
'                    oStockItem.MarkDownQuantity = oStockItem.MarkDownQuantity - mQuantitySold
                    lngQuantityAtHand = rsStock!QuantityAtHand
                    lngMarkDownQuantity = rsStock!MarkDownQuantity - mQuantitySold
                    lngQtySoldLF = 0
                    lngQtyMarkDownLF = mQuantitySold
                Else
'                    oStockItem.QuantityAtHand = oStockItem.QuantityAtHand - mQuantitySold
                    lngQuantityAtHand = rsStock!QuantityAtHand - mQuantitySold
                    lngMarkDownQuantity = rsStock!MarkDownQuantity
                    lngQtySoldLF = mQuantitySold
                    lngQtyMarkDownLF = 0
                End If
            End If
            
            'As these values are saved regardles, ensure they are initialised
            With rsStock
                lngUnitsSoldYesterday = !UnitsSoldYesterday
                lngUnitsSoldThisWeek = !UnitsSoldThisWeek
                lngUnitsSoldThisPeriod = !UnitsSoldThisPeriod
                lngUnitsSoldThisYear = !UnitsSoldThisYear
                
                curValueSoldYesterday = !ValueSoldYesterday
                curValueSoldThisWeek = !ValueSoldThisWeek
                curValueSoldThisPeriod = !ValueSoldThisPeriod
                curValueSoldThisYear = !ValueSoldThisYear
            End With
                
            If mMarkedDownStock Then
'                With oStockItem
                With rsStock
'                    .UnitsSoldYesterday = .UnitsSoldYesterday + mQuantitySold
'                    .UnitsSoldThisWeek = .UnitsSoldThisWeek + mQuantitySold
'                    .UnitsSoldThisPeriod = .UnitsSoldThisPeriod + mQuantitySold
'                    .UnitsSoldThisYear = .UnitsSoldThisYear + mQuantitySold
                    
                    cExtPrice = mExtendedValue - mQtyBreakMarginAmount - mDealGroupMarginAmount - _
                                                   mMultiBuyMarginAmount - mHierarchyMarginAmount
                                                   'mEmpSalePrimaryMarginAmount
                    
'                    .ValueSoldYesterday = .ValueSoldYesterday + cExtPrice
'                    .ValueSoldThisWeek = .ValueSoldThisWeek + cExtPrice
'                    .ValueSoldThisPeriod = .ValueSoldThisPeriod + cExtPrice
'                    .ValueSoldThisYear = .ValueSoldThisYear + cExtPrice
                    
                    lngUnitsSoldYesterday = !UnitsSoldYesterday + mQuantitySold
                    lngUnitsSoldThisWeek = !UnitsSoldThisWeek + mQuantitySold
                    lngUnitsSoldThisPeriod = !UnitsSoldThisPeriod + mQuantitySold
                    lngUnitsSoldThisYear = !UnitsSoldThisYear + mQuantitySold
                    
                    curValueSoldYesterday = !ValueSoldYesterday + cExtPrice
                    curValueSoldThisWeek = !ValueSoldThisWeek + cExtPrice
                    curValueSoldThisPeriod = !ValueSoldThisPeriod + cExtPrice
                    curValueSoldThisYear = !ValueSoldThisYear + cExtPrice
                
                    cExtPrice = mQuantitySold * mPriceOverrideAmount
                    
                    'call oconnection.Execute("Update STKMOV set adjv1
                    Set oStockMove = m_oSession.Database.CreateBusinessObject(CLASSID_STOCKMOVE)
                    Call oStockMove.SaveStockAdjustValue(mPartCode, cExtPrice)
                    Set oStockMove = Nothing
                    
                End With
            
'                If mMarkDownSerialNumber <> "" Then 'MO'C WIX 1302
'                    Set oMarkdown = m_oSession.Database.CreateBusinessObject(CLASSID_MARKDOWNSTOCK)
'                    Call oMarkdown.RecordAsSold(mPartCode, mMarkDownSerialNumber, mTranDate, mTransactionNumber, mTillID)
'
'                End If
                
            End If
            
'            Set oUpdateRow = New CRow
'            With oUpdateRow
'                Call .Add(oStockItem.GetField(FID_INVENTORY_PartCode))
'                Call .Add(oStockItem.GetField(FID_INVENTORY_MarkDownQuantity))
'                Call .Add(oStockItem.GetField(FID_INVENTORY_QuantityAtHand))
'                Call .Add(oStockItem.GetField(FID_INVENTORY_UnitsSoldYesterday))
'                Call .Add(oStockItem.GetField(FID_INVENTORY_UnitsSoldThisWeek))
'                Call .Add(oStockItem.GetField(FID_INVENTORY_UnitsSoldThisPeriod))
'                Call .Add(oStockItem.GetField(FID_INVENTORY_UnitsSoldThisYear))
'                Call .Add(oStockItem.GetField(FID_INVENTORY_ValueSoldYesterday))
'                Call .Add(oStockItem.GetField(FID_INVENTORY_ValueSoldThisWeek))
'                Call .Add(oStockItem.GetField(FID_INVENTORY_ValueSoldThisPeriod))
'                Call .Add(oStockItem.GetField(FID_INVENTORY_ValueSoldThisYear))
'            End With
'            Call m_oSession.Database.SavePartialBo(oStockItem, oUpdateRow)
'            Set oUpdateRow = Nothing
            
            With rsStock
                strError = ""
                strLogFile = "*" & mPartCode & "," & strMoveType & "," & lngQtySoldLF & "," & lngQtyMarkDownLF & _
                         "," & Format$(mTranDate, "DD/MM/YY") & mTillID & mTransactionNumber & mSequenceNo & "," & _
                         POSHeader.CashierID & "," & curStartPrice & "," & rsStock!NormalSellPrice & "*"
                strQuery = "INSERT INTO STKLOG (DATE1, TIME, SKUN, TYPE, KEYS, ICOM, EEID, SSTK, SRET, SPRI, SMDN, SWTF, ESTK, ERET, EPRI, EMDN, EWTF, DAYN) VALUES ('" & Format(Date, "yyyy-mm-dd") & "', '" & Format(Now, "HHMMSS") & "', '" & mPartCode & "', '" & strMoveType & "', '" & Format$(mTranDate, "DD/MM/YY") & mTillID & mTransactionNumber & mSequenceNo & "', 0, '" & POSHeader.CashierID & "', " & lngStartQty & ", " & lngStartRet & ", " & curStartPrice & ", " & lngStartMDQ & ", " & lngStartWOQ & ", " & lngQuantityAtHand & ", " & rsStock!UnitsInOpenReturns & ", " & rsStock!NormalSellPrice & ", " & lngMarkDownQuantity & ", " & rsStock!WriteOffQuantity & ", " & CLng(Date) - 1 & ")"

                rsStock.Close
                Set rsStock.ActiveConnection = Nothing
                On Error Resume Next
                Call m_oSession.Database.ExecuteCommand("update stkmas set ONHA = " & lngQuantityAtHand & ", MDNQ = " & lngMarkDownQuantity & ", SALU1 = " & lngUnitsSoldYesterday & ", SALU2 = " & lngUnitsSoldThisWeek & ", SALU4 = " & lngUnitsSoldThisPeriod & ", SALU6 = " & lngUnitsSoldThisYear & ", SALV1 = " & curValueSoldYesterday & ", SALV2 = " & curValueSoldThisWeek & ", SALV4 = " & curValueSoldThisPeriod & ", SALV6 = " & curValueSoldThisYear & " where SKUN = '" & mPartCode & "'")
        
                If oConnection.Errors.Count > 0 And Err.Number <> 0 Then
                    Dim I As Integer
                    For I = 0 To oConnection.Errors.Count - 1
                        strError = strError & oConnection.Errors(I).Number & " - " & oConnection.Errors(I).Description & vbCrLf
                    Next
                    oConnection.Errors.Clear
                ElseIf Err.Number <> 0 Then
                    strError = Err.Number & " - " & Err.Description
                    Err.Clear
                End If
                On Error GoTo 0
                
                If strError <> "" Then
                    Call DebugMsg(MODULE_NAME, "Save", endlDebug, "STKMAS skipped so Lock Failure")
                    Set oFileSys = New FileSystemObject
                    Set fErrorLog = oFileSys.OpenTextFile("f:\wix\" & mTillID & mTransactionNumber & mSequenceNo, ForWriting, True)
                    Call fErrorLog.WriteLine(strError)
                    Call fErrorLog.WriteLine(strLogFile)
                    fErrorLog.Close
                    
                    Set oFileSys = Nothing
                    Set fErrorLog = Nothing
                Else
                    'Changed 16/10/07 - if STKMAS updated then record STKLOG entry
                    Call DebugMsg(MODULE_NAME, "Save", endlDebug, "Insert StockLog")
                    Debug.Print strQuery
                    'Save StkLog entry only if ONHA updated on STKMAS correctly
                    If (strError = "") Then Call m_oSession.Database.ExecuteCommand(strQuery)
                    'Update Stock Movement History
                    Call DebugMsg(MODULE_NAME, "Save", endlDebug, "End Stock Tracking")
                End If
            End With
        End If 'Valid record that must update stock
    End If
    Save = True

End Function

Private Sub WriteIntoStkLogSystemAdjustment91(PartCode As String, CashierID As String, estkValue As Long, _
    eretValue As Long, emdnValue As Long, ewtfValue As Long, epriValue As Long, qtyValue As Long, retValue As Long, mdqValue As Long, _
    woqValue As Long, price As Currency)
    Dim strQuery As String
    
    strQuery = "INSERT INTO STKLOG (DATE1, TIME, SKUN, TYPE, KEYS, ICOM, EEID, SSTK, SRET, SMDN, SWTF, SPRI, ESTK, " & _
        "ERET, EMDN, EWTF, EPRI, DAYN) VALUES ('" & Format(Date, "yyyy-mm-dd") & "', '" & Format(Now, "HHMMSS") & "', '" & _
        PartCode & "', '91', 'System Adjustment 91', 0, '" & CashierID & "', " & estkValue & ", " & eretValue & ", " & _
        emdnValue & ", " & ewtfValue & ", " & epriValue & ", " & qtyValue & ", " & retValue & ", " & mdqValue & ", " & woqValue & _
        ", " & price & ", " & CLng(Date) - 1 & ")"
    Call m_oSession.Database.ExecuteCommand(strQuery)
End Sub

Private Function IsValid() As Boolean
'    Debug.Assert False
    IsValid = True
End Function


Private Function GetAllFieldsAsRow() As IRow
' Returns a CRow object containing one field object for each property.
    
Dim oRow    As IRow
Dim nFid    As Long
    
    Set oRow = New CRow
    For nFid = (CLASSID_POSLINE * &H10000) + 1 To FID_POSLINE_END_OF_STATIC Step 1
        oRow.Add GetField(nFid)
    Next nFid
    Set GetAllFieldsAsRow = oRow

End Function




'<CACH>****************************************************************************************
'* Function:  Boolean IBo_AddLoadFilter()
'**********************************************************************************************
'* Description: Part of the IBo Interface.  Used to set-up any selection criteria before
'*              calling the IBo_Load method.  This appends the selection criteria to the
'*              oRowSel object which is used by the IBo_Load method.
'**********************************************************************************************
'* Parameters:
'*In/Out:Comparator Long. - Comparison Type - see modBO.bas
'*In/Out:FieldID    Long. - Unique Field ID against which field to compare against
'*In/Out:Value  Variant. - Value that Field will be compared to
'**********************************************************************************************
'* Returns:  Boolean - True if Valid FieldID and successful
'**********************************************************************************************
'* History:
'* 08/10/02    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Function IBo_AddLoadFilter(Comparator As Long, FieldID As Long, Value As Variant) As Boolean
    IBo_AddLoadFilter = AddLoadFilter(Comparator, FieldID, Value)
End Function

Public Function AddLoadFilter(Comparator As Long, FieldID As Long, Value As Variant) As Boolean

Dim oField As IField

Const PROCEDURE_NAME As String = MODULE_NAME & ".AddLoadFilter"

    'Create field for storing Key into
    Set oField = GetField(FieldID)
    If oField Is Nothing Then Exit Function
    oField.ValueAsVariant = Value
    
    'Add field to Row selector
    If moRowSel Is Nothing Then Set moRowSel = New CRowSelector
    Call moRowSel.AddSelection(Comparator, oField)
    AddLoadFilter = True

End Function 'AddLoadFilter




'<CACH>****************************************************************************************
'* Function:  Boolean IBo_AddLoadField()
'**********************************************************************************************
'* Description: Part of the IBo Interface.  Used to set-up all fields that must be returned
'*              when using the LoadMatches method.  This appends the field to the oFieldRow
'*              object which is used by the IBo_LoadMatches method, if it is populated.
'**********************************************************************************************
'* Parameters:
'*In/Out:FieldID    Long. - Unique Field ID against which field to compare against
'**********************************************************************************************
'* History:
'* 09/10/02    mauricem
'*             Header added.
'</CACH>***************************************************************************************
Public Sub IBo_AddLoadField(FieldID As Long)
    AddLoadField FieldID
End Sub
Public Sub AddLoadField(FieldID As Long)

Const PROCEDURE_NAME As String = MODULE_NAME & ".AddLoadField"
    
    'Add field to Row selector
    If moLoadRow Is Nothing Then Set moLoadRow = m_oSession.Root.CreateUtilityObject("CRowSelector")
    Call moLoadRow.AddSelectAll(FieldID)

End Sub      'AddLoadField

Public Sub IBo_ClearLoadFilter()

    Set moRowSel = Nothing

End Sub

Public Sub IBo_ClearLoadField()

    Set moLoadRow = Nothing

End Sub

Public Function IBo_LoadMatches(Optional oReturnRow As IRow = Nothing) As Collection
    Set IBo_LoadMatches = LoadMatches(oReturnRow)
End Function

Public Function LoadMatches(Optional oReturnRow As IRow = Nothing) As Collection

' Load up all properties from the database
Dim oView       As IView
Dim colBO       As Collection
Dim oBO         As ISysBo
Dim lBONo       As Long
Dim oLoadFields As IRowSelector
    
    Set colBO = New Collection
    
    Call CheckIsUnInitialised(m_oSession, IBo_ClassName)
    
    Set oLoadFields = moRowSel
    If oLoadFields Is Nothing Then Set oLoadFields = New CRowSelector
    
    If oReturnRow Is Nothing Then
        If moLoadRow Is Nothing Then
            Call oLoadFields.Merge(GetSelectAllRow)
        Else
            Call oLoadFields.Merge(moLoadRow) ' add in the specified field
        End If
    Else
        Call oLoadFields.Merge(oReturnRow) ' add in the specified field
    End If
    
    ' Pass the selector to the database to get the data view
    Set oView = m_oSession.Database.GetView(oLoadFields)
    If Not (oView Is Nothing) Then
        For lBONo = 1 To oView.Count Step 1
            Set oBO = m_oSession.Database.CreateBusinessObject(IBo_ClassId)
            Call oBO.LoadFromRow(oView.Row(CLng(lBONo)))
            Call colBO.Add(oBO)
        Next lBONo
    End If
    
    Set LoadMatches = colBO

End Function


Private Function IBo_CreateNew() As IBo
    
    Set IBo_CreateNew = New cPOSLine

End Function


Private Function IBo_GetField(nFid As Long) As IField
    
    Set IBo_GetField = GetField(nFid)

End Function

Private Function IBo_GetSelectAllRow() As IRowSelector
    
    Set IBo_GetSelectAllRow = GetSelectAllRow

End Function

Public Function IBo_Load() As Boolean

    IBo_Load = Load

End Function


Private Function GetSelectAllRow() As IRowSelector
' Returns a CRow object containing one SelectAll field selector for each property.
    
    Set GetSelectAllRow = GetSelectAllRows(CLASSID_POSLINE, FID_POSLINE_END_OF_STATIC, m_oSession)

End Function

Public Function GetField(lFieldID As Long) As IField

    If CheckIsUnInitialised(m_oSession, IBo_ClassName) Then
        lFieldID = 0
        Exit Function
    End If
    On Error GoTo Error_Handler
    
    Select Case (lFieldID)
        Case (FID_POSLINE_TranDate):
                Set GetField = New CFieldDate
                GetField.ValueAsVariant = mTranDate
        Case (FID_POSLINE_TillID):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mTillID
        Case (FID_POSLINE_TransactionNumber):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mTransactionNumber
        Case (FID_POSLINE_SequenceNo):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mSequenceNo
        Case (FID_POSLINE_PartCode):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mPartCode
        Case (FID_POSLINE_DepartmentNumber):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mDepartmentNumber
        Case (FID_POSLINE_BarcodeEntry):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mBarcodeEntry
        Case (FID_POSLINE_QuantitySold):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mQuantitySold
        Case (FID_POSLINE_ActualSellPrice):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mActualSellPrice
        Case (FID_POSLINE_ExtendedValue):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mExtendedValue
        Case (FID_POSLINE_ExtendedCost):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mExtendedCost
        Case (FID_POSLINE_LookUpPrice):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mLookUpPrice
        Case (FID_POSLINE_VATCode):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mVATCode
        Case (FID_POSLINE_RelatedItems):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mRelatedItems
        Case (FID_POSLINE_CatchAllItem):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mCatchAllItem
        Case (FID_POSLINE_LineReversed):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mLineReversed
        Case (FID_POSLINE_PriceOverrideReason):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mPriceOverrideReason
        Case (FID_POSLINE_SupervisorNumber):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mSupervisorNumber
        Case (FID_POSLINE_ActualPriceExVAT):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mActualPriceExVAT
        Case (FID_POSLINE_OverrideMarginCode):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mOverrideMarginCode
        Case (FID_POSLINE_LastEventSequenceNo):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mLastEventSequenceNo
        Case (FID_POSLINE_HierCategory):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mHierCategory
        Case (FID_POSLINE_HierGroup):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mHierGroup
        Case (FID_POSLINE_HierSubGroup):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mHierSubGroup
        Case (FID_POSLINE_HierStyle):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mHierStyle
        Case (FID_POSLINE_QuarantineSupervisor):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mQuarantineSupervisor
        Case (FID_POSLINE_EmpSaleSecondaryMarginAmount):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mEmpSaleSecondaryMarginAmount
        Case (FID_POSLINE_MarkedDownStock):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mMarkedDownStock
        Case (FID_POSLINE_SaleType):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mSaleType
        Case (FID_POSLINE_VATCodeNumber):
                Set GetField = New CFieldLong
                GetField.ValueAsVariant = mVATCodeNumber
        Case (FID_POSLINE_PriceOverrideAmount):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mPriceOverrideAmount
        Case (FID_POSLINE_ItemTagged):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mItemTagged
        Case (FID_POSLINE_TempPriceMarginAmount):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mTempPriceMarginAmount
        Case (FID_POSLINE_TempPriceMarginCode):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mTempPriceMarginCode
        Case (FID_POSLINE_QtyBreakMarginAmount):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mQtyBreakMarginAmount
        Case (FID_POSLINE_QtyBreakMarginCode):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mQtyBreakMarginCode
        Case (FID_POSLINE_DealGroupMarginAmount):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mDealGroupMarginAmount
        Case (FID_POSLINE_DealGroupMarginCode):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mDealGroupMarginCode
        Case (FID_POSLINE_MultiBuyMarginAmount):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mMultiBuyMarginAmount
        Case (FID_POSLINE_MultiBuyMarginCode):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mMultiBuyMarginCode
        Case (FID_POSLINE_HierarchyMarginAmount):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mHierarchyMarginAmount
        Case (FID_POSLINE_HierarchyMarginCode):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mHierarchyMarginCode
        Case (FID_POSLINE_EmpSalePrimaryMarginAmount):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mEmpSalePrimaryMarginAmount
        Case (FID_POSLINE_EmpSalePrimaryMarginCode):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mEmpSalePrimaryMarginCode
        Case (FID_POSLINE_VATAmount):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mVATAmount
        Case (FID_POSLINE_BackDoorCollect):
                Set GetField = New CFieldString
                If (mBackDoorCollect = True) Then
                    GetField.ValueAsVariant = "Y"
                Else
                    GetField.ValueAsVariant = "N"
                End If
        Case (FID_POSLINE_BackDoorCollectInd):
                Set GetField = New CFieldBool
                GetField.ValueAsVariant = mBackDoorCollect
        Case (FID_POSLINE_WEEERate):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mWEEERate
        Case (FID_POSLINE_WEEESequence):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mWEEESequence
        Case (FID_POSLINE_WEEELineCharge):
                Set GetField = New CFieldDouble
                GetField.ValueAsVariant = mWEEELineCharge
        Case (FID_POSLINE_ReversalCode):
                Set GetField = New CFieldString
                GetField.ValueAsVariant = mReversalCode
        Case Else
                Call Err.Raise(OASYS_ERR_GETFIELD_INVALID_FID, MODULE_NAME, OASYS_ERR_GETFIELD_INVALID_FID_MSG & lFieldID)
    End Select
    
    If Not GetField Is Nothing Then GetField.Id = lFieldID
    
    Exit Function
    
Error_Handler:

    Call MsgBox(MODULE_NAME & " " & "GetField-" & lFieldID & vbCrLf & "Err:" & Err.Number & "-" & Err.Description)
    Resume Next

End Function

Private Function Initialise(oSession As ISession) As cPOSLine
    Set m_oSession = oSession
    Set Initialise = Me
End Function


Private Function IBo_Interface(Optional eInterfaceType As Long) As IBo

    

End Function

Public Function IBo_GetAllFieldsAsRow() As IRow
        
    Set IBo_GetAllFieldsAsRow = GetAllFieldsAsRow()

End Function

Public Function IBo_EndOfStaticFieldId() As Long

    IBo_EndOfStaticFieldId = FID_POSLINE_END_OF_STATIC

End Function

Friend Function GetFileLine() As String

Dim strOut As String
    strOut = vbNullString
    strOut = strOut & FmtVal(mTranDate, enftDate)
    strOut = strOut & FmtVal(mTillID, enftCode, 2)
    strOut = strOut & FmtVal(mTransactionNumber, enftCode, 4)
    strOut = strOut & FmtVal(mSequenceNo, enftCode, 5)
    strOut = strOut & FmtVal(mPartCode, enftCode, 6)
    strOut = strOut & FmtVal(mDepartmentNumber, enftCode, 2)
    strOut = strOut & FmtVal(mBarcodeEntry, enftYesNo)
    strOut = strOut & FmtVal(mSupervisorNumber, enftCode, 3)
    strOut = strOut & FmtVal(mQuantitySold, enftNumber, 6)
    strOut = strOut & FmtVal(mLookUpPrice, enftNumber, 8, 2)
    strOut = strOut & FmtVal(mActualSellPrice, enftNumber, 8, 2)
    strOut = strOut & FmtVal(mActualPriceExVAT, enftNumber, 8, 2)
    strOut = strOut & FmtVal(mExtendedValue, enftNumber, 8, 2)
    strOut = strOut & FmtVal(mExtendedCost, enftNumber, 9, 3)
    strOut = strOut & FmtVal(mRelatedItems, enftYesNo)
    strOut = strOut & FmtVal(mPriceOverrideReason, enftCode, 5)
    strOut = strOut & FmtVal(mItemTagged, enftYesNo)
    strOut = strOut & FmtVal(mCatchAllItem, enftYesNo)
    strOut = strOut & FmtVal(mVATCode, enftString, 1)
    strOut = strOut & FmtVal(mTempPriceMarginAmount, enftNumber, 8, 2)
    strOut = strOut & FmtVal(mTempPriceMarginCode, enftCode, 6)
    strOut = strOut & FmtVal(mPriceOverrideAmount, enftNumber, 8, 2)
    strOut = strOut & FmtVal(mOverrideMarginCode, enftCode, 6)
    strOut = strOut & FmtVal(mQtyBreakMarginAmount, enftNumber, 8, 2)
    strOut = strOut & FmtVal(mQtyBreakMarginCode, enftCode, 6)
    strOut = strOut & FmtVal(mDealGroupMarginAmount, enftNumber, 8, 2)
    strOut = strOut & FmtVal(mDealGroupMarginCode, enftCode, 6)
    strOut = strOut & FmtVal(mMultiBuyMarginAmount, enftNumber, 8, 2)
    strOut = strOut & FmtVal(mMultiBuyMarginCode, enftCode, 6)
    strOut = strOut & FmtVal(mHierarchyMarginAmount, enftNumber, 8, 2)
    strOut = strOut & FmtVal(mHierarchyMarginCode, enftCode, 6)
    strOut = strOut & FmtVal(mEmpSalePrimaryMarginAmount, enftNumber, 8, 2)
    strOut = strOut & FmtVal(mEmpSalePrimaryMarginCode, enftCode, 6)
    strOut = strOut & FmtVal(mLineReversed, enftYesNo)
    strOut = strOut & FmtVal(mLastEventSequenceNo, enftCode, 6)
    strOut = strOut & FmtVal(mHierCategory, enftCode, 6)
    strOut = strOut & FmtVal(mHierGroup, enftCode, 6)
    strOut = strOut & FmtVal(mHierSubGroup, enftCode, 6)
    strOut = strOut & FmtVal(mHierStyle, enftCode, 6)
    strOut = strOut & FmtVal(mQuarantineSupervisor, enftCode, 3)
    strOut = strOut & FmtVal(mEmpSaleSecondaryMarginAmount, enftNumber, 8, 2)
    strOut = strOut & FmtVal(mMarkedDownStock, enftYesNo)
    strOut = strOut & FmtVal(mSaleType, enftString, 1)
    strOut = strOut & FmtVal(mVATCodeNumber, enftNumber, 1)
    strOut = strOut & FmtVal(mVATAmount, enftNumber, 9, 2)
    strOut = strOut & FmtVal(IIf(mBackDoorCollect = True, "Y", "N"), enftString, 1)
    strOut = strOut & FmtVal(IIf(mBackDoorCollect = True, "Y", "N"), enftString, 1)
    strOut = strOut & FmtVal(mReversalCode, enftCode, 2)
    GetFileLine = strOut

End Function

